install.sh 33.6 KB
Newer Older
H
hzcheng 已提交
1 2
#!/bin/bash
#
L
lihui 已提交
3
# This file is used to install database on linux systems. The operating system
H
hzcheng 已提交
4 5 6 7 8
# is required to use systemd to manage services at boot

set -e
#set -x

L
lihui 已提交
9 10
verMode=edge
pagMode=full
S
slguan 已提交
11

H
Hui Li 已提交
12 13 14
iplist=""
serverFqdn=""

H
hzcheng 已提交
15
# -----------------------Variables definition---------------------
F
Frozen 已提交
16
script_dir=$(dirname $(readlink -f "$0"))
H
hzcheng 已提交
17 18 19 20 21 22 23 24 25 26 27
# Dynamic directory
data_dir="/var/lib/taos"
log_dir="/var/log/taos"

data_link_dir="/usr/local/taos/data"
log_link_dir="/usr/local/taos/log"

cfg_install_dir="/etc/taos"

bin_link_dir="/usr/bin"
lib_link_dir="/usr/lib"
H
Hui Li 已提交
28
lib64_link_dir="/usr/lib64"
H
hzcheng 已提交
29 30 31 32 33 34 35 36
inc_link_dir="/usr/include"

#install main path
install_main_dir="/usr/local/taos"

# old bin dir
bin_dir="/usr/local/taos/bin"

S
slguan 已提交
37
# v1.5 jar dir
H
Hui Li 已提交
38
#v15_java_app_dir="/usr/local/lib/taos"
S
slguan 已提交
39

H
hzcheng 已提交
40
service_config_dir="/etc/systemd/system"
S
slguan 已提交
41 42
nginx_port=6060
nginx_dir="/usr/local/nginxd"
H
hzcheng 已提交
43 44 45 46 47 48 49 50

# Color setting
RED='\033[0;31m'
GREEN='\033[1;32m'
GREEN_DARK='\033[0;32m'
GREEN_UNDERLINE='\033[4;32m'
NC='\033[0m'

P
plum-lihui 已提交
51 52 53 54
csudo=""
if command -v sudo > /dev/null; then
    csudo="sudo"
fi
H
hzcheng 已提交
55

S
slguan 已提交
56 57
update_flag=0

L
lihui 已提交
58
initd_mod=0
P
plum-lihui 已提交
59 60 61
service_mod=2
if pidof systemd &> /dev/null; then
    service_mod=0
L
lihui 已提交
62
elif $(which service &> /dev/null); then    
P
plum-lihui 已提交
63
    service_mod=1
L
lihui 已提交
64 65 66 67 68 69 70 71 72 73
    service_config_dir="/etc/init.d" 
    if $(which chkconfig &> /dev/null); then
         initd_mod=1 
    elif $(which insserv &> /dev/null); then
        initd_mod=2
    elif $(which update-rc.d &> /dev/null); then
        initd_mod=3
    else
        service_mod=2
    fi
P
plum-lihui 已提交
74 75
else 
    service_mod=2
H
hzcheng 已提交
76 77
fi

L
lihui 已提交
78 79 80 81

# get the operating system type for using the corresponding init file
# ubuntu/debian(deb), centos/fedora(rpm), others: opensuse, redhat, ..., no verification
#osinfo=$(awk -F= '/^NAME/{print $2}' /etc/os-release)
H
Hui Li 已提交
82
if [[ -e /etc/os-release ]]; then
H
Hui Li 已提交
83 84 85 86
  osinfo=$(cat /etc/os-release | grep "NAME" | cut -d '"' -f2)   ||:
else
  osinfo=""
fi
L
lihui 已提交
87 88 89
#echo "osinfo: ${osinfo}"
os_type=0
if echo $osinfo | grep -qwi "ubuntu" ; then
H
Hui Li 已提交
90
#  echo "This is ubuntu system"
L
lihui 已提交
91 92
  os_type=1
elif echo $osinfo | grep -qwi "debian" ; then
H
Hui Li 已提交
93
#  echo "This is debian system"
L
lihui 已提交
94 95
  os_type=1
elif echo $osinfo | grep -qwi "Kylin" ; then
H
Hui Li 已提交
96
#  echo "This is Kylin system"
L
lihui 已提交
97 98
  os_type=1
elif  echo $osinfo | grep -qwi "centos" ; then
H
Hui Li 已提交
99
#  echo "This is centos system"
L
lihui 已提交
100 101
  os_type=2
elif echo $osinfo | grep -qwi "fedora" ; then
H
Hui Li 已提交
102
#  echo "This is fedora system"
L
lihui 已提交
103 104
  os_type=2
else
H
Hui Li 已提交
105 106 107 108
  echo " osinfo: ${osinfo}"
  echo " This is an officially unverified linux system," 
  echo " if there are any problems with the installation and operation, "
  echo " please feel free to contact taosdata.com for support."
L
lihui 已提交
109
  os_type=1
L
lihui 已提交
110 111
fi

H
Hui Li 已提交
112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147

# =============================  get input parameters =================================================

# install.sh -v [server | client]  -e [yes | no] -i [systemd | service | ...]

# set parameters by default value
interactiveFqdn=yes   # [yes | no]
verType=server        # [server | client]
initType=systemd      # [systemd | service | ...]

while getopts "hv:e:i:" arg
do
  case $arg in
    e)
      #echo "interactiveFqdn=$OPTARG"
      interactiveFqdn=$( echo $OPTARG )
      ;;
    v)
      #echo "verType=$OPTARG"
      verType=$(echo $OPTARG)
      ;;
    i)
      #echo "initType=$OPTARG"
      initType=$(echo $OPTARG)
      ;;
    h)
      echo "Usage: `basename $0` -v [server | client]  -e [yes | no]"
      exit 0
      ;;
    ?) #unknow option 
      echo "unkonw argument"
      exit 1
      ;;
  esac
done

H
Hui Li 已提交
148
#echo "verType=${verType} interactiveFqdn=${interactiveFqdn}"
H
Hui Li 已提交
149

P
plum-lihui 已提交
150 151
function kill_taosd() {
  pid=$(ps -ef | grep "taosd" | grep -v "grep" | awk '{print $2}')
L
lihui 已提交
152 153 154
  if [ -n "$pid" ]; then
    ${csudo} kill -9 $pid   || :
  fi
P
plum-lihui 已提交
155 156
}

H
hzcheng 已提交
157 158
function install_main_path() {
    #create install main dir and all sub dir
P
plum-lihui 已提交
159 160 161 162 163 164 165 166 167
    ${csudo} rm -rf ${install_main_dir}    || :
    ${csudo} mkdir -p ${install_main_dir}  
    ${csudo} mkdir -p ${install_main_dir}/cfg
    ${csudo} mkdir -p ${install_main_dir}/bin    
    ${csudo} mkdir -p ${install_main_dir}/connector
    ${csudo} mkdir -p ${install_main_dir}/driver
    ${csudo} mkdir -p ${install_main_dir}/examples
    ${csudo} mkdir -p ${install_main_dir}/include
    ${csudo} mkdir -p ${install_main_dir}/init.d
S
slguan 已提交
168 169 170
    if [ "$verMode" == "cluster" ]; then
        ${csudo} mkdir -p ${nginx_dir}
    fi
H
hzcheng 已提交
171 172 173 174
}

function install_bin() {
    # Remove links
P
plum-lihui 已提交
175 176
    ${csudo} rm -f ${bin_link_dir}/taos     || :
    ${csudo} rm -f ${bin_link_dir}/taosd    || :
S
slguan 已提交
177
    ${csudo} rm -f ${bin_link_dir}/taosdemo || :
H
Hui Li 已提交
178
    ${csudo} rm -f ${bin_link_dir}/taosdemox || :
179
    ${csudo} rm -f ${bin_link_dir}/taosdump || :
P
plum-lihui 已提交
180
    ${csudo} rm -f ${bin_link_dir}/rmtaos   || :
H
Hui Li 已提交
181
    ${csudo} rm -f ${bin_link_dir}/tarbitrator   || :
H
Hui Li 已提交
182
    ${csudo} rm -f ${bin_link_dir}/set_core   || :
H
hzcheng 已提交
183

P
plum-lihui 已提交
184
    ${csudo} cp -r ${script_dir}/bin/* ${install_main_dir}/bin && ${csudo} chmod 0555 ${install_main_dir}/bin/*
H
hzcheng 已提交
185 186

    #Make link
H
Hui Li 已提交
187 188 189
    [ -x ${install_main_dir}/bin/taos ] && ${csudo} ln -s ${install_main_dir}/bin/taos ${bin_link_dir}/taos                      || :
    [ -x ${install_main_dir}/bin/taosd ] && ${csudo} ln -s ${install_main_dir}/bin/taosd ${bin_link_dir}/taosd                   || :
    [ -x ${install_main_dir}/bin/taosdemo ] && ${csudo} ln -s ${install_main_dir}/bin/taosdemo ${bin_link_dir}/taosdemo          || :
H
Hui Li 已提交
190
    [ -x ${install_main_dir}/bin/taosdemox ] && ${csudo} ln -s ${install_main_dir}/bin/taosdemox ${bin_link_dir}/taosdemox       || :
191
    [ -x ${install_main_dir}/bin/taosdump ] && ${csudo} ln -s ${install_main_dir}/bin/taosdump ${bin_link_dir}/taosdump          || :
H
Hui Li 已提交
192
    [ -x ${install_main_dir}/bin/remove.sh ] && ${csudo} ln -s ${install_main_dir}/bin/remove.sh ${bin_link_dir}/rmtaos          || :
H
Hui Li 已提交
193
    [ -x ${install_main_dir}/bin/set_core.sh ] && ${csudo} ln -s ${install_main_dir}/bin/set_core.sh ${bin_link_dir}/set_core    || :
H
Hui Li 已提交
194
    [ -x ${install_main_dir}/bin/tarbitrator ] && ${csudo} ln -s ${install_main_dir}/bin/tarbitrator ${bin_link_dir}/tarbitrator || :
S
slguan 已提交
195 196 197 198 199 200

    if [ "$verMode" == "cluster" ]; then
        ${csudo} cp -r ${script_dir}/nginxd/* ${nginx_dir} && ${csudo} chmod 0555 ${nginx_dir}/*
        ${csudo} mkdir -p ${nginx_dir}/logs
        ${csudo} chmod 777 ${nginx_dir}/sbin/nginx
    fi
H
hzcheng 已提交
201 202 203 204
}

function install_lib() {
    # Remove links
L
lihui 已提交
205
    ${csudo} rm -f ${lib_link_dir}/libtaos.*         || :
H
Hui Li 已提交
206
    ${csudo} rm -f ${lib64_link_dir}/libtaos.*       || :
H
Hui Li 已提交
207
    #${csudo} rm -rf ${v15_java_app_dir}              || :
P
plum-lihui 已提交
208
    ${csudo} cp -rf ${script_dir}/driver/* ${install_main_dir}/driver && ${csudo} chmod 777 ${install_main_dir}/driver/*  
H
hzcheng 已提交
209
    
P
plum-lihui 已提交
210 211
    ${csudo} ln -s ${install_main_dir}/driver/libtaos.* ${lib_link_dir}/libtaos.so.1
    ${csudo} ln -s ${lib_link_dir}/libtaos.so.1 ${lib_link_dir}/libtaos.so
S
slguan 已提交
212
    
H
Hui Li 已提交
213
    if [[ -d ${lib64_link_dir} && ! -e ${lib64_link_dir}/libtaos.so ]]; then
H
Hui Li 已提交
214 215 216
      ${csudo} ln -s ${install_main_dir}/driver/libtaos.* ${lib64_link_dir}/libtaos.so.1       || :
      ${csudo} ln -s ${lib64_link_dir}/libtaos.so.1 ${lib64_link_dir}/libtaos.so               || :
    fi
H
Hui Li 已提交
217
        
H
Hui Li 已提交
218 219 220 221 222 223
	  #if [ "$verMode" == "cluster" ]; then
    #    # Compatible with version 1.5
    #    ${csudo} mkdir -p ${v15_java_app_dir}
    #    ${csudo} ln -s ${install_main_dir}/connector/taos-jdbcdriver-1.0.2-dist.jar ${v15_java_app_dir}/JDBCDriver-1.0.2-dist.jar
    #    ${csudo} chmod 777 ${v15_java_app_dir} || :
    #fi
H
Hui Li 已提交
224 225
    
    ${csudo} ldconfig
H
hzcheng 已提交
226 227 228
}

function install_header() {
L
lihui 已提交
229
    ${csudo} rm -f ${inc_link_dir}/taos.h ${inc_link_dir}/taoserror.h    || :
P
plum-lihui 已提交
230 231
    ${csudo} cp -f ${script_dir}/inc/* ${install_main_dir}/include && ${csudo} chmod 644 ${install_main_dir}/include/*    
    ${csudo} ln -s ${install_main_dir}/include/taos.h ${inc_link_dir}/taos.h
L
lihui 已提交
232
    ${csudo} ln -s ${install_main_dir}/include/taoserror.h ${inc_link_dir}/taoserror.h
H
hzcheng 已提交
233 234
}

H
Hui Li 已提交
235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385
function add_newHostname_to_hosts() {
  localIp="127.0.0.1"
  OLD_IFS="$IFS"
  IFS=" "
  iphost=$(cat /etc/hosts | grep $1 | awk '{print $1}')
  arr=($iphost)
  IFS="$OLD_IFS"
  for s in ${arr[@]}
  do
    if [[ "$s" == "$localIp" ]]; then
      return
    fi
  done 
  ${csudo} echo "127.0.0.1  $1" >> /etc/hosts   ||:
}

function set_hostname() {
  echo -e -n "${GREEN}Please enter one hostname(must not be 'localhost')${NC}:"
	read newHostname
  while true; do
    if [[ ! -z "$newHostname" && "$newHostname" != "localhost" ]]; then
      break
    else
      read -p "Please enter one hostname(must not be 'localhost'):" newHostname
    fi
  done

  ${csudo} hostname $newHostname ||:
  retval=`echo $?`
  if [[ $retval != 0 ]]; then
   echo
   echo "set hostname fail!"
   return 
  fi
  #echo -e -n "$(hostnamectl status --static)"
  #echo -e -n "$(hostnamectl status --transient)"
  #echo -e -n "$(hostnamectl status --pretty)"
  
  #ubuntu/centos /etc/hostname
  if [[ -e /etc/hostname ]]; then
    ${csudo} echo $newHostname > /etc/hostname   ||:
  fi
  
  #debian: #HOSTNAME=yourname
  if [[ -e /etc/sysconfig/network ]]; then
    ${csudo} sed -i -r "s/#*\s*(HOSTNAME=\s*).*/\1$newHostname/" /etc/sysconfig/network   ||:
  fi

  ${csudo} sed -i -r "s/#*\s*(fqdn\s*).*/\1$newHostname/" ${cfg_install_dir}/taos.cfg
  serverFqdn=$newHostname  
  
  if [[ -e /etc/hosts ]]; then
    add_newHostname_to_hosts $newHostname
  fi
}

function is_correct_ipaddr() {
  newIp=$1
  OLD_IFS="$IFS"
  IFS=" "
  arr=($iplist)
  IFS="$OLD_IFS"
  for s in ${arr[@]}
  do
   if [[ "$s" == "$newIp" ]]; then
     return 0
   fi
  done
  
  return 1
}

function set_ipAsFqdn() {
  iplist=$(ip address |grep inet |grep -v inet6 |grep -v 127.0.0.1 |awk '{print $2}' |awk -F "/" '{print $1}') ||:
  if [ -z "$iplist" ]; then
    iplist=$(ifconfig |grep inet |grep -v inet6 |grep -v 127.0.0.1 |awk '{print $2}' |awk -F ":" '{print $2}') ||:
  fi

  if [ -z "$iplist" ]; then
    echo
    echo -e -n "${GREEN}Unable to get local ip, use 127.0.0.1${NC}"
    localFqdn="127.0.0.1"
    # Write the local FQDN to configuration file                    
    ${csudo} sed -i -r "s/#*\s*(fqdn\s*).*/\1$localFqdn/" ${cfg_install_dir}/taos.cfg    
    serverFqdn=$localFqdn
    echo
    return
  fi  
  
  echo -e -n "${GREEN}Please choose an IP from local IP list${NC}:"
  echo
  echo -e -n "${GREEN}$iplist${NC}"
  echo
  echo
  echo -e -n "${GREEN}Notes: if IP is used as the node name, data can NOT be migrated to other machine directly${NC}:"
  read localFqdn
    while true; do
      if [ ! -z "$localFqdn" ]; then            
        # Check if correct ip address
        is_correct_ipaddr $localFqdn
        retval=`echo $?`
        if [[ $retval != 0 ]]; then
          read -p "Please choose an IP from local IP list:" localFqdn
        else
          # Write the local FQDN to configuration file                    
          ${csudo} sed -i -r "s/#*\s*(fqdn\s*).*/\1$localFqdn/" ${cfg_install_dir}/taos.cfg    
          serverFqdn=$localFqdn
          break
        fi
      else
        read -p "Please choose an IP from local IP list:" localFqdn
      fi
    done
}

function local_fqdn_check() {
  #serverFqdn=$(hostname -f)
  echo
  echo -e -n "System hostname is: ${GREEN}$serverFqdn${NC}"
  echo
  if [[ "$serverFqdn" == "" ]] || [[ "$serverFqdn" == "localhost"  ]]; then    
    echo -e -n "${GREEN}It is strongly recommended to configure a hostname for this machine ${NC}"
    echo
    
    while true
    do
	    read -r -p "Set hostname now? [Y/n] " input
	    if [ ! -n "$input" ]; then
       set_hostname
       break
      else
	      case $input in
	        [yY][eE][sS]|[yY])
          set_hostname
          break
			    ;;
        
	        [nN][oO]|[nN])
			    set_ipAsFqdn
			    break   	
			    ;;
        
	        *)
			    echo "Invalid input..."
			    ;;
	      esac
	    fi
    done
  fi
}

H
hzcheng 已提交
386
function install_config() {
P
plum-lihui 已提交
387
    #${csudo} rm -f ${install_main_dir}/cfg/taos.cfg     || :
H
hzcheng 已提交
388
    
L
lihui 已提交
389
    if [ ! -f ${cfg_install_dir}/taos.cfg ]; then
P
plum-lihui 已提交
390 391 392
        ${csudo} mkdir -p ${cfg_install_dir}
        [ -f ${script_dir}/cfg/taos.cfg ] && ${csudo} cp ${script_dir}/cfg/taos.cfg ${cfg_install_dir}
        ${csudo} chmod 644 ${cfg_install_dir}/*
H
hzcheng 已提交
393 394
    fi 
    
P
plum-lihui 已提交
395
    ${csudo} cp -f ${script_dir}/cfg/taos.cfg ${install_main_dir}/cfg/taos.cfg.org
L
lihui 已提交
396
    ${csudo} ln -s ${cfg_install_dir}/taos.cfg ${install_main_dir}/cfg
S
slguan 已提交
397

H
Hui Li 已提交
398
    [ ! -z $1 ] && return 0 || : # only install client
S
slguan 已提交
399
    
H
Hui Li 已提交
400 401 402 403 404 405
    if ((${update_flag}==1)); then
        return 0
    fi
    
    if [ "$interactiveFqdn" == "no" ]; then
        return 0
H
Hui Li 已提交
406 407 408
    fi   	
    
    local_fqdn_check
S
slguan 已提交
409

H
Hui Li 已提交
410 411 412 413 414 415 416
    #FQDN_FORMAT="(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)"
    #FQDN_FORMAT="(:[1-6][0-9][0-9][0-9][0-9]$)"
    #PORT_FORMAT="(/[1-6][0-9][0-9][0-9][0-9]?/)"
    #FQDN_PATTERN=":[0-9]{1,5}$"

    # first full-qualified domain name (FQDN) for TDengine cluster system
    echo
H
Hui Li 已提交
417
    echo -e -n "${GREEN}Enter FQDN:port (like h1.taosdata.com:6030) of an existing TDengine cluster node to join${NC}"
H
Hui Li 已提交
418
    echo
H
Hui Li 已提交
419
    echo -e -n "${GREEN}OR leave it blank to build one${NC}:"
H
Hui Li 已提交
420
    read firstEp
H
Hui Li 已提交
421 422 423 424 425 426
    while true; do
        if [ ! -z "$firstEp" ]; then
            # check the format of the firstEp
            #if [[ $firstEp == $FQDN_PATTERN ]]; then
                # Write the first FQDN to configuration file                    
                ${csudo} sed -i -r "s/#*\s*(firstEp\s*).*/\1$firstEp/" ${cfg_install_dir}/taos.cfg    
S
slguan 已提交
427
                break
H
Hui Li 已提交
428 429 430 431 432 433 434
            #else
            #    read -p "Please enter the correct FQDN:port: " firstEp
            #fi
        else
            break
        fi
    done	
H
Hui Li 已提交
435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457

    # user email 
    #EMAIL_PATTERN='^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$'
    #EMAIL_PATTERN='^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$'
    #EMAIL_PATTERN="^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$"
    echo
    echo -e -n "${GREEN}Enter your email address for priority support or enter empty to skip${NC}: "
    read emailAddr
    while true; do
        if [ ! -z "$emailAddr" ]; then
            # check the format of the emailAddr
            #if [[ "$emailAddr" =~ $EMAIL_PATTERN ]]; then
                # Write the email address to temp file                    
                email_file="${install_main_dir}/email" 
                ${csudo} bash -c "echo $emailAddr > ${email_file}"
                break         
            #else
            #    read -p "Please enter the correct email address: " emailAddr   
            #fi
        else
            break
        fi
    done	
H
hzcheng 已提交
458 459
}

L
lihui 已提交
460

H
hzcheng 已提交
461
function install_log() {
P
plum-lihui 已提交
462 463
    ${csudo} rm -rf ${log_dir}  || :
    ${csudo} mkdir -p ${log_dir} && ${csudo} chmod 777 ${log_dir}
H
hzcheng 已提交
464
    
P
plum-lihui 已提交
465
    ${csudo} ln -s ${log_dir} ${install_main_dir}/log
H
hzcheng 已提交
466 467 468
}

function install_data() {
P
plum-lihui 已提交
469
    ${csudo} mkdir -p ${data_dir}
H
hzcheng 已提交
470
    
P
plum-lihui 已提交
471
    ${csudo} ln -s ${data_dir} ${install_main_dir}/data    
H
hzcheng 已提交
472 473 474
}

function install_connector() {
475
    ${csudo} cp -rf ${script_dir}/connector/ ${install_main_dir}/
H
hzcheng 已提交
476 477 478
}

function install_examples() {
S
slguan 已提交
479 480 481
    if [ -d ${script_dir}/examples ]; then
        ${csudo} cp -rf ${script_dir}/examples/* ${install_main_dir}/examples
    fi
H
hzcheng 已提交
482 483 484
}

function clean_service_on_sysvinit() {
L
lihui 已提交
485 486 487
    #restart_config_str="taos:2345:respawn:${service_config_dir}/taosd start"
    #${csudo} sed -i "\|${restart_config_str}|d" /etc/inittab || :    
    
H
hzcheng 已提交
488
    if pidof taosd &> /dev/null; then
P
plum-lihui 已提交
489
        ${csudo} service taosd stop || :
H
hzcheng 已提交
490
    fi
H
Hui Li 已提交
491 492 493 494
    
    if pidof tarbitrator &> /dev/null; then
        ${csudo} service tarbitratord stop || :
    fi
L
lihui 已提交
495 496

    if ((${initd_mod}==1)); then
H
Hui Li 已提交
497
      if [ -e ${service_config_dir}/taosd ]; then 
L
lihui 已提交
498
        ${csudo} chkconfig --del taosd || :
H
Hui Li 已提交
499 500 501
      fi

      if [ -e ${service_config_dir}/tarbitratord ]; then 
H
Hui Li 已提交
502
        ${csudo} chkconfig --del tarbitratord || :
H
Hui Li 已提交
503
      fi
L
lihui 已提交
504
    elif ((${initd_mod}==2)); then
H
Hui Li 已提交
505
      if [ -e ${service_config_dir}/taosd ]; then 
L
lihui 已提交
506
        ${csudo} insserv -r taosd || :
H
Hui Li 已提交
507 508
      fi
      if [ -e ${service_config_dir}/tarbitratord ]; then
H
Hui Li 已提交
509
        ${csudo} insserv -r tarbitratord || :
H
Hui Li 已提交
510
      fi
L
lihui 已提交
511
    elif ((${initd_mod}==3)); then
H
Hui Li 已提交
512
      if [ -e ${service_config_dir}/taosd ]; then
L
lihui 已提交
513
        ${csudo} update-rc.d -f taosd remove || :
H
Hui Li 已提交
514 515
      fi
      if [ -e ${service_config_dir}/tarbitratord ]; then
H
Hui Li 已提交
516
        ${csudo} update-rc.d -f tarbitratord remove || :
H
Hui Li 已提交
517
      fi
L
lihui 已提交
518 519
    fi
    
P
plum-lihui 已提交
520
    ${csudo} rm -f ${service_config_dir}/taosd || :
H
Hui Li 已提交
521
    ${csudo} rm -f ${service_config_dir}/tarbitratord || :
L
lihui 已提交
522 523 524 525
    
    if $(which init &> /dev/null); then
        ${csudo} init q || :
    fi
H
hzcheng 已提交
526 527 528 529 530 531 532
}

function install_service_on_sysvinit() {
    clean_service_on_sysvinit
    sleep 1

    # Install taosd service
L
lihui 已提交
533 534 535 536

    if ((${os_type}==1)); then
        ${csudo} cp -f ${script_dir}/init.d/taosd.deb ${install_main_dir}/init.d/taosd
        ${csudo} cp    ${script_dir}/init.d/taosd.deb ${service_config_dir}/taosd && ${csudo} chmod a+x ${service_config_dir}/taosd
H
Hui Li 已提交
537 538
        ${csudo} cp -f ${script_dir}/init.d/tarbitratord.deb ${install_main_dir}/init.d/tarbitratord
        ${csudo} cp    ${script_dir}/init.d/tarbitratord.deb ${service_config_dir}/tarbitratord && ${csudo} chmod a+x ${service_config_dir}/tarbitratord
L
lihui 已提交
539 540 541
    elif ((${os_type}==2)); then
        ${csudo} cp -f ${script_dir}/init.d/taosd.rpm ${install_main_dir}/init.d/taosd
        ${csudo} cp    ${script_dir}/init.d/taosd.rpm ${service_config_dir}/taosd && ${csudo} chmod a+x ${service_config_dir}/taosd
H
Hui Li 已提交
542 543
        ${csudo} cp -f ${script_dir}/init.d/tarbitratord.rpm ${install_main_dir}/init.d/tarbitratord
        ${csudo} cp    ${script_dir}/init.d/tarbitratord.rpm ${service_config_dir}/tarbitratord && ${csudo} chmod a+x ${service_config_dir}/tarbitratord
L
lihui 已提交
544 545 546 547 548 549 550 551
    fi
    
    #restart_config_str="taos:2345:respawn:${service_config_dir}/taosd start"
    #${csudo} grep -q -F "$restart_config_str" /etc/inittab || ${csudo} bash -c "echo '${restart_config_str}' >> /etc/inittab"
    
    if ((${initd_mod}==1)); then
        ${csudo} chkconfig --add taosd || :
        ${csudo} chkconfig --level 2345 taosd on || :
H
Hui Li 已提交
552 553
        ${csudo} chkconfig --add tarbitratord || :
        ${csudo} chkconfig --level 2345 tarbitratord on || :
L
lihui 已提交
554 555 556
    elif ((${initd_mod}==2)); then
        ${csudo} insserv taosd || :
        ${csudo} insserv -d taosd || :
H
Hui Li 已提交
557 558
        ${csudo} insserv tarbitratord || :
        ${csudo} insserv -d tarbitratord || :
L
lihui 已提交
559 560
    elif ((${initd_mod}==3)); then
        ${csudo} update-rc.d taosd defaults || :
H
Hui Li 已提交
561
        ${csudo} update-rc.d tarbitratord defaults || :
L
lihui 已提交
562
    fi
H
hzcheng 已提交
563 564 565 566 567 568
}

function clean_service_on_systemd() {
    taosd_service_config="${service_config_dir}/taosd.service"
    if systemctl is-active --quiet taosd; then
        echo "TDengine is running, stopping it..."
P
plum-lihui 已提交
569
        ${csudo} systemctl stop taosd &> /dev/null || echo &> /dev/null
H
hzcheng 已提交
570
    fi
P
plum-lihui 已提交
571 572
    ${csudo} systemctl disable taosd &> /dev/null || echo &> /dev/null
    ${csudo} rm -f ${taosd_service_config}
H
Hui Li 已提交
573 574 575 576 577 578 579 580 581
    
    tarbitratord_service_config="${service_config_dir}/tarbitratord.service"
    if systemctl is-active --quiet tarbitratord; then
        echo "tarbitrator is running, stopping it..."
        ${csudo} systemctl stop tarbitratord &> /dev/null || echo &> /dev/null
    fi
    ${csudo} systemctl disable tarbitratord &> /dev/null || echo &> /dev/null
    ${csudo} rm -f ${tarbitratord_service_config}
        
S
slguan 已提交
582 583 584 585 586 587 588
    if [ "$verMode" == "cluster" ]; then
        nginx_service_config="${service_config_dir}/nginxd.service"
        if systemctl is-active --quiet nginxd; then
            echo "Nginx for TDengine is running, stopping it..."
            ${csudo} systemctl stop nginxd &> /dev/null || echo &> /dev/null
        fi
        ${csudo} systemctl disable nginxd &> /dev/null || echo &> /dev/null
H
Hui Li 已提交
589 590
        ${csudo} rm -f ${nginx_service_config}              
	  fi
S
slguan 已提交
591
}
H
hzcheng 已提交
592 593 594 595 596 597 598

# taos:2345:respawn:/etc/init.d/taosd start

function install_service_on_systemd() {
    clean_service_on_systemd

    taosd_service_config="${service_config_dir}/taosd.service"
P
plum-lihui 已提交
599 600 601 602 603 604 605 606
    ${csudo} bash -c "echo '[Unit]'                             >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Description=TDengine server service' >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'After=network-online.target'        >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Wants=network-online.target'        >> ${taosd_service_config}"
    ${csudo} bash -c "echo                                      >> ${taosd_service_config}"
    ${csudo} bash -c "echo '[Service]'                          >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Type=simple'                        >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'ExecStart=/usr/bin/taosd'           >> ${taosd_service_config}"
H
Hui Li 已提交
607 608 609
    #${csudo} bash -c "echo 'ExecStartPre=/usr/local/taos/bin/setDelay.sh'     >> ${taosd_service_config}"
    #${csudo} bash -c "echo 'ExecStartPost=/usr/local/taos/bin/resetDelay.sh'  >> ${taosd_service_config}"
    #${csudo} bash -c "echo 'ExecStopPost=/usr/local/taos/bin/resetDelay.sh'   >> ${taosd_service_config}"
P
plum-lihui 已提交
610 611 612 613 614 615 616 617
    ${csudo} bash -c "echo 'LimitNOFILE=infinity'               >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'LimitNPROC=infinity'                >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'LimitCORE=infinity'                 >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'TimeoutStartSec=0'                  >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'StandardOutput=null'                >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'Restart=always'                     >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'StartLimitBurst=3'                  >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'StartLimitInterval=60s'             >> ${taosd_service_config}"
H
Hui Li 已提交
618
    #${csudo} bash -c "echo 'StartLimitIntervalSec=60s'          >> ${taosd_service_config}"
P
plum-lihui 已提交
619 620 621 622
    ${csudo} bash -c "echo                                      >> ${taosd_service_config}"
    ${csudo} bash -c "echo '[Install]'                          >> ${taosd_service_config}"
    ${csudo} bash -c "echo 'WantedBy=multi-user.target'         >> ${taosd_service_config}"
    ${csudo} systemctl enable taosd
H
Hui Li 已提交
623
    
H
Hui Li 已提交
624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646
    tarbitratord_service_config="${service_config_dir}/tarbitratord.service"
    ${csudo} bash -c "echo '[Unit]'                                  >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Description=TDengine arbitrator service' >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'After=network-online.target'             >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Wants=network-online.target'             >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo                                           >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo '[Service]'                               >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Type=simple'                             >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'ExecStart=/usr/bin/tarbitrator'          >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'LimitNOFILE=infinity'                    >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'LimitNPROC=infinity'                     >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'LimitCORE=infinity'                      >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'TimeoutStartSec=0'                       >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'StandardOutput=null'                     >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'Restart=always'                          >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'StartLimitBurst=3'                       >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'StartLimitInterval=60s'                  >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo                                           >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo '[Install]'                               >> ${tarbitratord_service_config}"
    ${csudo} bash -c "echo 'WantedBy=multi-user.target'              >> ${tarbitratord_service_config}"
    #${csudo} systemctl enable tarbitratord  
        
    if [ "$verMode" == "cluster" ]; then		
S
slguan 已提交
647
        nginx_service_config="${service_config_dir}/nginxd.service"
H
Hui Li 已提交
648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668
        ${csudo} bash -c "echo '[Unit]'                                             >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Description=Nginx For TDengine Service'             >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'After=network-online.target'                        >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Wants=network-online.target'                        >> ${nginx_service_config}"
        ${csudo} bash -c "echo                                                      >> ${nginx_service_config}"
        ${csudo} bash -c "echo '[Service]'                                          >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Type=forking'                                       >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'PIDFile=/usr/local/nginxd/logs/nginx.pid'           >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'ExecStart=/usr/local/nginxd/sbin/nginx'             >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'ExecStop=/usr/local/nginxd/sbin/nginx -s stop'      >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'LimitNOFILE=infinity'                               >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'LimitNPROC=infinity'                                >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'LimitCORE=infinity'                                 >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'TimeoutStartSec=0'                                  >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'StandardOutput=null'                                >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'Restart=always'                                     >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'StartLimitBurst=3'                                  >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'StartLimitInterval=60s'                             >> ${nginx_service_config}"
        ${csudo} bash -c "echo                                                      >> ${nginx_service_config}"
        ${csudo} bash -c "echo '[Install]'                                          >> ${nginx_service_config}"
        ${csudo} bash -c "echo 'WantedBy=multi-user.target'                         >> ${nginx_service_config}"
S
slguan 已提交
669 670 671 672 673 674
        if ! ${csudo} systemctl enable nginxd &> /dev/null; then
            ${csudo} systemctl daemon-reexec
            ${csudo} systemctl enable nginxd
        fi
        ${csudo} systemctl start nginxd
	fi
H
hzcheng 已提交
675 676 677
}

function install_service() {
P
plum-lihui 已提交
678
    if ((${service_mod}==0)); then
H
hzcheng 已提交
679
        install_service_on_systemd
P
plum-lihui 已提交
680
    elif ((${service_mod}==1)); then
H
hzcheng 已提交
681
        install_service_on_sysvinit
P
plum-lihui 已提交
682
    else
L
lihui 已提交
683
        # must manual stop taosd
P
plum-lihui 已提交
684
        kill_taosd
H
hzcheng 已提交
685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718
    fi
}

vercomp () {
    if [[ $1 == $2 ]]; then
        return 0
    fi
    local IFS=.
    local i ver1=($1) ver2=($2)
    # fill empty fields in ver1 with zeros
    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
        ver1[i]=0
    done

    for ((i=0; i<${#ver1[@]}; i++)); do
        if [[ -z ${ver2[i]} ]]
        then
            # fill empty fields in ver2 with zeros
            ver2[i]=0
        fi
        if ((10#${ver1[i]} > 10#${ver2[i]}))
        then
            return 1
        fi
        if ((10#${ver1[i]} < 10#${ver2[i]}))
        then
            return 2
        fi
    done
    return 0
}

function is_version_compatible() {

L
lihui 已提交
719
    curr_version=$(${bin_dir}/taosd -V | head -1 | cut -d ' ' -f 3)
H
hzcheng 已提交
720

L
lihui 已提交
721
    min_compatible_version=$(${script_dir}/bin/taosd -V | head -1 | cut -d ' ' -f 5)
H
hzcheng 已提交
722 723 724 725 726 727 728 729 730 731 732 733 734 735 736

    vercomp $curr_version $min_compatible_version
    case $? in
        0) return 0;;
        1) return 0;;
        2) return 1;;
    esac
}

function update_TDengine() {
    # Start to update
    if [ ! -e taos.tar.gz ]; then
        echo "File taos.tar.gz does not exist"
        exit 1
    fi
L
lihui 已提交
737
    tar -zxf taos.tar.gz
H
hzcheng 已提交
738 739 740 741 742 743 744

    # Check if version compatible
    if ! is_version_compatible; then
        echo -e "${RED}Version incompatible${NC}"
        return 1
    fi

L
lihui 已提交
745
    echo -e "${GREEN}Start to update TDengine...${NC}"
H
hzcheng 已提交
746 747
    # Stop the service if running
    if pidof taosd &> /dev/null; then
P
plum-lihui 已提交
748 749 750 751
        if ((${service_mod}==0)); then
            ${csudo} systemctl stop taosd || :
        elif ((${service_mod}==1)); then
            ${csudo} service taosd stop || :
H
hzcheng 已提交
752
        else
P
plum-lihui 已提交
753
            kill_taosd
H
hzcheng 已提交
754 755 756 757 758 759 760 761 762
        fi
        sleep 1
    fi
    
    install_main_path

    install_log
    install_header
    install_lib
L
lihui 已提交
763 764 765
    if [ "$pagMode" != "lite" ]; then
      install_connector
    fi
H
hzcheng 已提交
766 767 768 769
    install_examples
    if [ -z $1 ]; then
        install_bin
        install_service
H
Hui Li 已提交
770
        install_config		
S
slguan 已提交
771
		
H
Hui Li 已提交
772
        openresty_work=false
H
Hui Li 已提交
773
		    if [ "$verMode" == "cluster" ]; then    
S
slguan 已提交
774 775 776 777 778 779 780 781 782 783
            # Check if openresty is installed
            # Check if nginx is installed successfully
            if type curl &> /dev/null; then
                if curl -sSf http://127.0.0.1:${nginx_port} &> /dev/null; then
                    echo -e "\033[44;32;1mNginx for TDengine is updated successfully!${NC}"
                    openresty_work=true
                else
                    echo -e "\033[44;31;5mNginx for TDengine does not work! Please try again!\033[0m"
                fi
            fi
H
Hui Li 已提交
784
		    fi 
H
hzcheng 已提交
785

H
Hui Li 已提交
786 787
        #echo
        #echo -e "\033[44;32;1mTDengine is updated successfully!${NC}"
H
hzcheng 已提交
788 789
        echo
        echo -e "${GREEN_DARK}To configure TDengine ${NC}: edit /etc/taos/taos.cfg"
P
plum-lihui 已提交
790 791 792
        if ((${service_mod}==0)); then
            echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} systemctl start taosd${NC}"
        elif ((${service_mod}==1)); then
L
lihui 已提交
793
            echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} service taosd start${NC}"
H
hzcheng 已提交
794
        else
P
plum-lihui 已提交
795
            echo -e "${GREEN_DARK}To start TDengine     ${NC}: ./taosd${NC}"
H
hzcheng 已提交
796 797
        fi

H
Hui Li 已提交
798
        if [ ${openresty_work} = 'true' ]; then
H
Hui Li 已提交
799
            echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos -h $serverFqdn${NC} in shell OR from ${GREEN_UNDERLINE}http://127.0.0.1:${nginx_port}${NC}"
S
slguan 已提交
800
        else
H
Hui Li 已提交
801
            echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos -h $serverFqdn${NC} in shell${NC}"
S
slguan 已提交
802
        fi
H
Hui Li 已提交
803
                
H
hzcheng 已提交
804 805 806
        echo
        echo -e "\033[44;32;1mTDengine is updated successfully!${NC}"
    else
L
lihui 已提交
807
        install_bin
H
hzcheng 已提交
808 809 810 811 812 813 814 815 816 817 818 819
        install_config

        echo
        echo -e "\033[44;32;1mTDengine client is updated successfully!${NC}"
    fi

    rm -rf $(tar -tf taos.tar.gz)
}

function install_TDengine() {
    # Start to install
    if [ ! -e taos.tar.gz ]; then
H
Hui Li 已提交
820 821
      echo "File taos.tar.gz does not exist"
      exit 1
H
hzcheng 已提交
822
    fi
L
lihui 已提交
823
    tar -zxf taos.tar.gz
H
hzcheng 已提交
824

L
lihui 已提交
825
    echo -e "${GREEN}Start to install TDengine...${NC}"
H
hzcheng 已提交
826 827 828 829 830 831 832 833 834 835
    
	  install_main_path
	   
    if [ -z $1 ]; then
        install_data
    fi 
    
    install_log 
    install_header
    install_lib
L
lihui 已提交
836 837 838
    if [ "$pagMode" != "lite" ]; then
      install_connector
    fi
H
hzcheng 已提交
839 840 841 842 843 844
    install_examples

    if [ -z $1 ]; then # install service and client
        # For installing new
        install_bin
        install_service
S
slguan 已提交
845

H
Hui Li 已提交
846 847
        openresty_work=false
        if [ "$verMode" == "cluster" ]; then
S
slguan 已提交
848 849 850 851 852 853 854 855 856 857 858
            # Check if nginx is installed successfully
            if type curl &> /dev/null; then
                if curl -sSf http://127.0.0.1:${nginx_port} &> /dev/null; then
                    echo -e "\033[44;32;1mNginx for TDengine is installed successfully!${NC}"
                    openresty_work=true
                else
                    echo -e "\033[44;31;5mNginx for TDengine does not work! Please try again!\033[0m"
                fi
            fi
        fi
		
H
hzcheng 已提交
859 860 861
        install_config	

        # Ask if to start the service
H
Hui Li 已提交
862 863
        #echo
        #echo -e "\033[44;32;1mTDengine is installed successfully!${NC}"
H
hzcheng 已提交
864 865
        echo
        echo -e "${GREEN_DARK}To configure TDengine ${NC}: edit /etc/taos/taos.cfg"
P
plum-lihui 已提交
866
        if ((${service_mod}==0)); then
H
Hui Li 已提交
867
          echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} systemctl start taosd${NC}"
P
plum-lihui 已提交
868
        elif ((${service_mod}==1)); then
H
Hui Li 已提交
869
          echo -e "${GREEN_DARK}To start TDengine     ${NC}: ${csudo} service taosd start${NC}"
H
hzcheng 已提交
870
        else
H
Hui Li 已提交
871
          echo -e "${GREEN_DARK}To start TDengine     ${NC}: taosd${NC}"
H
Hui Li 已提交
872 873
        fi		

H
Hui Li 已提交
874 875 876 877 878
        #if [ ${openresty_work} = 'true' ]; then
        #     echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos${NC} in shell OR from ${GREEN_UNDERLINE}http://127.0.0.1:${nginx_port}${NC}"
        #else
        #     echo -e "${GREEN_DARK}To access TDengine    ${NC}: use ${GREEN_UNDERLINE}taos${NC} in shell${NC}"
        #fi
S
slguan 已提交
879
		
H
Hui Li 已提交
880
        if [ ! -z "$firstEp" ]; then
H
Hui Li 已提交
881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897
          tmpFqdn=${firstEp%%:*}
          substr=":"
          if [[ $firstEp =~ $substr ]];then
            tmpPort=${firstEp#*:}
          else
            tmpPort=""
          fi
          if [[ "$tmpPort" != "" ]];then
	          echo -e "${GREEN_DARK}To access TDengine    ${NC}: taos -h $tmpFqdn -P $tmpPort${GREEN_DARK} to login into cluster, then${NC}"
	        else
	          echo -e "${GREEN_DARK}To access TDengine    ${NC}: taos -h $tmpFqdn${GREEN_DARK} to login into cluster, then${NC}"
	        fi
	        echo -e "${GREEN_DARK}execute ${NC}: create dnode 'newDnodeFQDN:port'; ${GREEN_DARK}to add this new node${NC}"
          echo
        elif [ ! -z "$serverFqdn" ]; then
	        echo -e "${GREEN_DARK}To access TDengine    ${NC}: taos -h $serverFqdn${GREEN_DARK} to login into TDengine server${NC}"
          echo
S
slguan 已提交
898
        fi
H
Hui Li 已提交
899
        
H
hzcheng 已提交
900
        echo -e "\033[44;32;1mTDengine is installed successfully!${NC}"
H
Hui Li 已提交
901
        echo       
H
hzcheng 已提交
902 903 904 905 906 907
    else # Only install client
        install_bin
        install_config
        echo
        echo -e "\033[44;32;1mTDengine client is installed successfully!${NC}"
    fi
908
    touch ~/.taos_history
H
hzcheng 已提交
909 910 911 912 913
    rm -rf $(tar -tf taos.tar.gz)
}


## ==============================Main program starts from here============================
H
Hui Li 已提交
914
serverFqdn=$(hostname -f)
H
Hui Li 已提交
915
if [ "$verType" == "server" ]; then
H
hzcheng 已提交
916 917
    # Install server and client
    if [ -x ${bin_dir}/taosd ]; then
S
slguan 已提交
918
        update_flag=1
H
hzcheng 已提交
919 920 921 922
        update_TDengine
    else
        install_TDengine
    fi
H
Hui Li 已提交
923 924
elif [ "$verType" == "client" ]; then
    interactiveFqdn=no
H
hzcheng 已提交
925 926
    # Only install client
    if [ -x ${bin_dir}/taos ]; then
S
slguan 已提交
927
        update_flag=1
H
hzcheng 已提交
928 929 930 931
        update_TDengine client
    else
        install_TDengine client
    fi
H
Hui Li 已提交
932 933
else 
    echo  "please input correct verType"   
H
hzcheng 已提交
934
fi